local assets=
{
    Asset("ANIM", "anim/triciawand.zip"),
    Asset("ANIM", "anim/swap_triciawand.zip"),

    Asset("ATLAS", "images/inventoryimages/triciawand.xml"),
    Asset("IMAGE", "images/inventoryimages/triciawand.tex"),
}


local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_triciawand", "swap_ham_bat")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
    
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function onattack( inst, owner, target )
    local summonchance = 0.03
    if math.random() < summonchance then 
        local pt = target:GetPosition()
        local st_pt =  FindWalkableOffset(pt or owner:GetPosition(), math.random()*2*PI, 2, 3)
        local ores = {"bird_egg","tallbirdegg"}
        local ore = ores[math.random(#ores)]
        if st_pt then
            st_pt = st_pt + pt
            local st1 = SpawnPrefab(ore)
            local st2 = SpawnPrefab("collapse_small")
            st1.Transform:SetPosition(st_pt.x, st_pt.y, st_pt.z)
            st2.Transform:SetPosition(pt.x, pt.y, pt.z)
        end
    end
    local sayrate = 0.3
    if math.random() < sayrate then
        inst:PushEvent("triciaattack")
    end
end

local function fn(Sim)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("ham_bat")
    anim:SetBuild("triciawand")
    anim:PlayAnimation("idle")
    
    inst:AddComponent("weapon")
    -- TUNING.HAMBAT_DAMAGE = 59.5
    -- TUNING.BATBAT_DAMAGE = 42.5
    inst.components.weapon:SetDamage(TUNING.HAMBAT_DAMAGE)
    inst.components.weapon.onattack = onattack
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "triciawand"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/triciawand.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    -- walk speed
    inst.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT

    -- say something
    inst:AddComponent("sentienttricia")
    inst:AddComponent("talker")
    inst.components.talker.fontsize = 28
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(255/255,211/255,120/255)
    inst.components.talker.offset = Vector3(0,0,0)
    inst.components.talker.symbol = "swap_object"


    return inst
end

return Prefab( "common/inventory/triciawand", fn, assets) 